/* Datei:  test_lcd.c
 * Author: gkemnitz
 * Datum:  11.09.2016
 *
 * Beispiel zu Foliensatz 4
 * Ausgabe einer Zeichenkette auf das LCD
 *
 * PModCLS mittlerer Stecker (J2) mit Kabel an JD 
 * oben. Auf PModCLS Jumber MD0 und MD2 stecken.
 */ 

#include <avr/io.h>

void lcd_init() {
  // Initialisierung von USART1
  UCSR1C = 0b110;                  // bertragungsformat 8N1
  UBRR1  = 51;                     // 9600 Baud
  UCSR1B = (1<<TXEN1);             // Sender ein
}
uint8_t LCD_dat[]="\x1B[0h\x1B[j"  // Init-String (8 Zeichen)
               "A=... Err:......"  // 1. Zeile (16 Zeichen)
               "S:... Inp:......"; // 2. Zeile (16 Zeichen)
uint8_t idx;                       // Indexvariable

int main(void) {
  lcd_init();                      // USART1 initialisieren
  for(idx=0; idx<39; idx++) {      // fr alle 40 Zeichen
    while (!(UCSR1A&(1<<UDRE1)));  // warte, bis Puffer frei
    UDR1 = LCD_dat[idx];           // Zeichen in Puffer
  }
}
