/* Datei:  comsf_pc.c
 * Author: gkemnitz
 * Datum:  27.10.2015
 *
 * Quellprogramm fr den Gertetreiber comsf_pc
 *
 * PmodUSBUSART an JH oben
 */  

#include "comsf_pc.h"

uint8_t rmsg[COM_PC_RMSG_LEN];  // Empfangs- und Sendepuffer
uint8_t smsg[COM_PC_SMSG_LEN];

uint8_t sidx, ridx, last_byte;  // Pufferidx., zuletzt empfangens Byte

void com_pc_init(){             // Initialisierung fr USART2
  UCSR2C=0b110;	                // bertragungsformat 8N1
  UBRR2=51;                     // 9600 Baud
  UCSR2B=(1<<RXEN2)|(1<<TXEN2); // Sender und Empfnger ein
  ridx = 0;                     // Empfangspuffer leer
  sidx = COM_PC_SMSG_LEN;       // Sendepuffer leer
  last_byte = (uint8_t)' ';     // Initialisierung mit Leerzeichen
}

void com_pc_step(){             // Schrittfunktion
  if (UCSR2A & (1<<RXC2)){      // wenn Byte empfangen
    last_byte = UDR2;           // Byte lesen
    if (ridx < COM_PC_RMSG_LEN){// wenn Platz
      rmsg[ridx] = last_byte;   // in Puffer bernehmen
      ridx++;
    }
  }
  if (UCSR2A & (1<<UDRE2) && sidx < COM_PC_SMSG_LEN){
    UDR2 = smsg[sidx];          // wenn Sendepuffer frei
    sidx++;                     // und Senddaten, versenden
  }
}
	
uint8_t com_pc_get(uint8_t *msg){
  if (ridx < COM_PC_RMSG_LEN)   // wenn der Empfangspuffer nicht
    return 0;                   // voll, Rcksprung mit "erfolglos"
  for (ridx=0; ridx<COM_PC_RMSG_LEN;ridx++)
    msg[ridx] = rmsg[ridx];     // sonst Empfangsnachricht kopieren
  ridx = 0;                     // Empfangspuffer leeren
  return 1;                     // Rcksprung mit "Daten erhalten"
}
	
uint8_t com_pc_send(uint8_t *msg){
  if (sidx < COM_PC_SMSG_LEN)   // wenn der Sendepuffer nicht
    return 0;                   // leer, Rckgabe "erfolglos"
  for (sidx=0; sidx<COM_PC_SMSG_LEN;sidx++)
    smsg[sidx] = msg[sidx];     // sonst Sendenachricht bergeben
                                // und Zeiger auf Nachrichtenanfang
  sidx = 0;                     // Sendepuffer voll
  return 1;                     // Rcksprung mit "Daten bernommen"
}

void com_pc_rmsg_clr(){         // lschen des Empfangspuffers
	ridx = 0;
}

uint8_t com_pc_last_byte(){     // Rckgabe letztes Byte
	return last_byte;
}
