/* Datei:  test_interrupt.c
 * Autor: gkemnitz
 * letzte Änderung: 27.09.2016
 *
 * Experimentierprogramm zum Aufzeigen typischer Probleme
 * und Fehler bei der Nutzung von Interrupts
 *
 * LED-Modul an Port C
 */  

#include <avr/io.h>
#include <avr/interrupt.h>

uint16_t LED_Ct;

//ISR Timer-3-Vergleichsinterrupt A, alle 1 ms
ISR(TIMER3_COMPA_vect){
  LED_Ct++;
  if (LED_Ct>=500){        // alle 500 ms
    PORTJ++;               // LEDs hochzählen
    LED_Ct = 0;            // Zähler rücksetzen
  }
}		


// ISR zur Behandlung ungewollter Interrupts
/*
ISR(BADISR_vect){	
  PORTC++;                  // LED-Ausgabe an Port C hochzählen
}
*/


int main(void) {
  DDRJ  = 0xFF;             // LEDs an Port J als Ausgänge
  DDRC  = 0xFF;             // LED-Modul an Port C Ausgänge
  PORTJ = 0;
  PORTC+= 1;
  // Timer 3: Clear on Compare Match mit OCR3A, 
  TCCR3B = (1<<WGM32)|(0b001<<CS30); // Vorteiler 1
  OCR3A  = 8000;            // 1 ms Aufrufperiode
  TIMSK3 = 1<<OCIE3A;       // Timer3-Comp.A-Interrupt ein
  // Interrupt ohne ISR (schlechter Int. ca. alle 8s)
  TCCR1B = 0b101;           // Timer 1, Normalmodus, Vorteiler 1024
  TIMSK1=0;                 // keine Interrupt-Freigabe
  //TIMSK1 = 1<<TOIE1;      // Überlauf-Interrupt ein 
  sei();                    // Interrupts global freigeben
  while(1){
//  uint8_t INTZ = TIMSK3;  // Interrupt-Zustand sichern
//  TIMSK3 &= ~(1<<OCIE3A); // Interrupt sperren
//  PORTJ ^= 0x80;          // LD8 umschalten
//  TIMSK3 = INTZ;          // Int-Zustand wiederherst.
  };
}
