/* Datei:  test_rotmess.c
 * Autor: gkemnitz
 * letzte nderung: 28.11.2016
 *
 * Testprogramm fr die Messung der Umdrehungs-
 * geschwindigkeit in Abhngigkeit von der pwm-
 * Breite und der Signalperiode
 *
 * PmodUSBUSART an JH oben
 * beide PModHB5 mit Motoren ber Y-Kabel an JL.
 * JHX und JLX "gekreuzt (=)"
 */  


#include <avr/io.h>
#include "comir_pc.h"
#include "pwm.h"
#include "rotmess.h"
#include <avr/interrupt.h>

uint8_t rmsg[COM_PC_RMSG_LEN];
uint8_t smsg[COM_PC_SMSG_LEN];

int main(){
  int16_t speed_R, speed_L, pwm;
  uint8_t state=0;     // Programmzustand
	
  rotmess_init();      // initialisieren aller Treiber
  com_pc_init();
  pwm_init();
  DDRJ = 0xFF;         // LED-Ausgabe aktivieren
  sei();               // Interrupts einschalten

  while(1){
    if (state == 0){
      if (com_pc_get(rmsg)){ // wenn neue Nachricht
        pwm = rmsg[0]<<8 | rmsg[1];
        pwm_set_R(pwm);	  // Wert fr Motor R einstellen
        pwm = rmsg[2]<<8 | rmsg[3];
        pwm_set_L(pwm);   // Wert fr Motor L einstellen
        OCR5A = rmsg[4]<<8 | rmsg[5];
        pwm_start();
        state = 1;
      }
      else
        pwm_stop();
    }
    if (state && rotmess_get(&speed_R, &speed_L)){
      state++;            // nach jeder Messung Zustand++
			// Ausgabe des Zustands und Bit 7 als Fehlerbit
			PORTJ = state | rotmess_err()<<7;
      if (state>3){       // 3. Messergebnis zum PC senden
        smsg[0] = rmsg[0];		smsg[1] = rmsg[1];
        smsg[2] = speed_R>>8;	smsg[3] = speed_R & 0xff;
        smsg[4] = rmsg[2];		smsg[5] = rmsg[3];
        smsg[6] = speed_L>>8; smsg[7] = speed_L & 0xff;
        com_pc_send(smsg);
        state=0;
      }
    }
  }
}